// file: lightmap.h
// definice datovch typ pro lightmapy
//

#ifndef __LIGHTMAP_ICLUDED
#define __LIGHTMAP_ICLUDED

#include "Light.h"

struct Lightmap {
	int n_width, n_height;
	int A_1, A_2, A_3, B_1;
	float *p_buffer;
	//
	char *p_s_filename;
};

struct Mesh {
	int n_lightmap_num;
	int n_object_num;
    int n_material_num;
	//
	Lightmap *p_lightmap;
	Object *p_object;
    Material *p_material;
	//
	Mapping_Info *p_m_info;
	Group_Data *p_g_data;
};

int Create_Lightmaps(char *p_s_filename, Mesh *p_mesh);

float f_Find_GreatestRadiativeEnergy(Mesh *p_mesh, Vector *v_texel_pos,
									 Vector *v_texel_normal, int *n, Vector *v_rad_color);

void Refine_Edges(Mesh *p_mesh);
void Blur_Illumination(Mesh *p_mesh, int n_strength);

#endif //__LIGHTMAP_ICLUDED