/*
								+---------------------------------+
								|                                 |
								|     ***   Rasterizer   ***      |
								|                                 |
								|  Copyright   -tHE SWINe- 2002  |
								|                                 |
								|            Raster.h             |
								|                                 |
								+---------------------------------+
*/

#ifndef __RASTERIZER_INCLUDED
#define __RASTERIZER_INCLUDED

int Init_Engine(int n_New_Width, int n_New_Height);
void Terminate_Engine();

void PreCalc_Multab();

void Set_RenderTarget(int nActivate);

void DrawObject(Matrix *m_object, Matrix *m_camera,
    Object *p_object, Material *p_material, Lightmap *p_lightmap);

Texture *Load_Texture(char *filename);

int Load_Textures(World *world, char *dir);
int Load_Textures(Mesh *mesh, char *dir);

void Generate_Scanline_Graph();

void SubWindow(int n_sub_width, int n_sub_height);

int Release_Screen(unsigned __int32 *vram);
int Release_Screen_LinearBuff(unsigned __int32 *vram);
void Init_Screen();

void Clipper(int n_sub_width, int n_sub_height);

void Line(Matrix m_projection, Vertex *v_a, Vertex *v_b,
	unsigned __int32 *vram, unsigned __int32 color);

void Set_FormFactors(float *p_form_factors, Vector v_radiative_energy);

enum {
	RenderTarget_Illumination = 0,
	RenderTarget_Radiate,
	RenderTarget_Radiation,
	RenderTarget_Illumination_High
};

#endif